﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace _389458
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            RadDropDownListCustom ddl = new RadDropDownListCustom();
            ddl.IsReadOnly = true;

            ddl.Items.Add("Item 1");
            ddl.Items.Add("Item 2");
            ddl.Items.Add("Item 3");
            ddl.Items.Add("Item 4");
            this.Controls.Add(ddl);
            ddl.SelectedItem = ddl.Items[0];
        }
    }

    public class RadDropDownListCustom : RadDropDownList
    {

        private bool m_IsReadOnly;
        private event EventHandler<EventArgs> ReadOnlyChanged;

        public bool IsReadOnly
        {
            get { return m_IsReadOnly; }
            set
            {
                m_IsReadOnly = value;
                if (ReadOnlyChanged != null)
                {
                    ReadOnlyChanged(this, new EventArgs());
                }
            }
        }

        private void Me_ReadOnlyChanged(object sender, EventArgs e)
        {
            if (m_IsReadOnly)
            {
                PopupOpening += Me_PopUpShowing;
                DropDownListElement.TextBox.TextBoxItem.ReadOnly = true;
                DropDownListElement.ArrowButton.Visibility = Telerik.WinControls.ElementVisibility.Collapsed;

            }
            else
            {
                PopupOpening -= Me_PopUpShowing;
                DropDownListElement.TextBox.TextBoxItem.ReadOnly = false;
                DropDownListElement.ArrowButton.Visibility = Telerik.WinControls.ElementVisibility.Visible;

            }
        }

        private void Me_PopUpShowing(object sender, CancelEventArgs e)
        {
            e.Cancel = m_IsReadOnly;
        }
        public RadDropDownListCustom()
        {
            ReadOnlyChanged += Me_ReadOnlyChanged;
        }

    }
}
